
#    Note:  This is loaded into the namespace  ASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
	variable FileBase "/MIDAS/XilinxLinux/ppc_4xx/rfs/"
	variable MyName nnaida3 ; # [global env; set env(ComputerName)]
	
    variable JS ""

    variable ASICList {1 2 3 4}
    variable ASIC [first $ASICList]

    variable allmodules 0
    variable allasics 0

    variable ASIC_result {}

    for {set i 0} {$i < 28} {incr i} {
#        variable Opts.Value$i 0
        variable Opts.Offset$i $i
    }
# this set are displayed
variable ASIC_d0	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASIC_d1	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASIC_d2	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASIC_d3	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
# this set are for the load default
variable ASICdf_d0	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASICdf_d1	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASICdf_d2	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASICdf_d3	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
# this set are for the check
variable ASICck_d0	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASICck_d1	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASICck_d2	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }
variable ASICck_d3	{ 4 5 6 2 7 8 9 4 0 3 0 4 0x0F 0x34 0x0F 0x0F 0xD2 0x80 0xB2 0x5C 0x68 8 0x5C 8 0x68 8 0xCA 0 }

variable Opts.Bits0	5  
variable Opts.Bits1	5    
variable Opts.Bits2	5  
variable Opts.Bits3	5  
variable Opts.Bits4	5   
variable Opts.Bits5	5 
variable Opts.Bits6	5 
variable Opts.Bits7	4  
variable Opts.Bits8	1     
variable Opts.Bits9	4   
variable Opts.Bits10	1  
variable Opts.Bits11	4
variable Opts.Bits12	8 
variable Opts.Bits13	8
variable Opts.Bits14	8
variable Opts.Bits15	8
variable Opts.Bits16	8
variable Opts.Bits17	8
variable Opts.Bits18	8
variable Opts.Bits19	8
variable Opts.Bits20	8
variable Opts.Bits21	4
variable Opts.Bits22	8
variable Opts.Bits23	4
variable Opts.Bits24	8
variable Opts.Bits25	4
variable Opts.Bits26	8
variable Opts.Bits27	3

    variable         Opts.Title0  "preamp reset"
    variable         Opts.Title1  "shaper reset"
    variable         Opts.Title2  "filter reset"
    variable         Opts.Title3  "fast filter reset"
    variable         Opts.Title4  "peak hold reset"
    variable         Opts.Title5  "clamp reset"
    variable         Opts.Title6  "comparator reset"
    variable         Opts.Title7  "hold timing"
    variable         Opts.Title8  "low_ref (pre-amp polarity)"
    variable         Opts.Title9  "shaping time"
    variable         Opts.Title10  "medium/low energy selection"
    variable         Opts.Title11  "clamp threshold"
    variable         Opts.Title12  "slow comparator threshold"
    variable         Opts.Title13  "shaper reference"
    variable         Opts.Title14  "fast comparator threshold HEC"
    variable         Opts.Title15  "fast comparator threshold LEC/MEC"
    variable         Opts.Title16  "vsasc_n for buffers"
    variable         Opts.Title17  "vsasc_p for buffers"
    variable         Opts.Title18  "preAmp reference"
    variable         Opts.Title19  "biasRC preamp HEC"
    variable         Opts.Title20  "vcasc_preamp HEC"
    variable         Opts.Title21  "Ibias LF feedback"
    variable         Opts.Title22  "biasRC preamp"
    variable         Opts.Title23  "Ibias preamp SF"
    variable         Opts.Title24  "vcasc_preamp LEC"
    variable         Opts.Title25  "Ibias preamp"
    variable         Opts.Title26  "diode link threshold"
    variable         Opts.Title27  ""

proc load_BB {} { 
	variable ASIC_d0
	variable ASIC_d1
	variable ASIC_d2
	variable ASIC_d3
	variable FileBase
	variable MyName
	
	set bitIndex 0
	set bit_list {}
	set MyName [ exec uname -n ]
	set Host [ exec uname -m ]
	if { $Host == "ppc" } { ;# we're in a FEE so need to execute the C program after writing the file to /tmp
		for { set k 0 }  { $k < 28 } { incr k } {
			set i [ expr 27 - $k ]
			variable Opts.Bits$i

			set a [ lindex [ set ASIC_d0 ] $i ] 
			set b [ lindex [ set ASIC_d1 ] $i ] 
			set c [ lindex [ set ASIC_d2 ] $i ] 
			set d [ lindex [ set ASIC_d3 ] $i ] 

			set Nbits [ set Opts.Bits$i ]
			for { set j 0 } { $j < $Nbits } { incr j }  { ;# Output MSB first
				set s [ expr $Nbits - 1 - $j ]	;# should give the correct number of shifts starting MSB first
				set thisBit [ expr ( ( $a >> $s ) & 1 ) + ( ( ( $b >> $s ) & 1 ) << 1 ) + ( ( ( $c >> $s ) & 1 ) << 2 ) + ( ( ( $d >> $s ) & 1 ) << 3 ) ]
				set bit_list [ lappend bit_list $thisBit ]
				set bitIndex [ expr $bitIndex + 1 ]
			}

		}
		set filename [ file join / tmp "asic.txt" ] ;# only do this if the machine is an FEE64 
		set fp [ open $filename w ]
		for { set i 0 } { $i < 160 } { incr i } { ;# same format as the read file
			set thisBit [ lindex $bit_list $i ]
			set string  [ format "%01X" $thisBit ]
			puts $fp $string
	#		InsertLog "$i : $thisBit : $string"
	# data written to file now run the load program
		}
		close $fp
		InsertLog "Data written to $filename"
		
		set execute "exec /MIDAS/Aida/FEE64/load_asics.o /tmp/asic.txt"
		set rc [catch {eval $execute} m]
		if { $rc != 0 } {
			puts "Command returned rc = $rc | m = $m"
			return -1
		}
		InsertLog " ASIC load program operated OK"
	} else {
		InsertLog "Not ppc! Load_BB:arrived here in error"
		set m "Not ppc! Load_BB:arrived here in error"
		return $m

	}
}
	
# read_BB removed as it doesn't get called

proc check_BB {} {
	variable ASIC_result
	variable ASIC_d0
	variable ASIC_d1
	variable ASIC_d2
	variable ASIC_d3
	variable ASICck_d0
	variable ASICck_d1
	variable ASICck_d2
	variable ASICck_d3
	InsertLog "Check_BB called"
	
	set execute "exec uname -m"
	set rc [catch {eval $execute} m]
	if { $rc != 0 } {
		puts "Command returned rc = $rc | m = $m"
		return -1
	}
	InsertLog "Host name is $m"
	if { $m == "ppc" } {
#call the C program read_asics which will output the data for parsing to rdata MSB first .... 
		set execute "exec /MIDAS/Aida/FEE64/read_asics.o"
		set rc [catch {eval $execute} m]
		if { $rc != 0 } {
			puts "Command returned rc = $rc | m = $m"
			return -1
		}
		InsertLog "Read Program returned OK"

		set bit_list [ split $m "\n" ] ; # this should leave a list of four bit values 160 long.
		set Bindex 1
		for { set k 0 }  { $k < 28 } { incr k } {
			set i [ expr 27 - $k ]
			variable Opts.Bits$i				;# fetch the number of bits required
			set Nbits [ set Opts.Bits$i ]
			set a 0 ; set b 0 ; set c 0 ; set d 0 ; # clear out the shifters
			for { set j 0 } { $j < $Nbits } { incr j }  { ;# Output MSB first
				set rc [ scan [lindex $bit_list $Bindex ] "%1x" thisBit ]
				if { $rc == 1 } {
					set a [ expr  ( $a << 1 ) + ( $thisBit & 1 ) ]
					set b [ expr  ( $b << 1 ) + ( ( $thisBit >> 1 )& 1 ) ]
					set c [ expr  ( $c << 1 ) + ( ( $thisBit >> 2 )& 1 ) ]
					set d [ expr  ( $d << 1 ) + ( ( $thisBit >> 3 )& 1 ) ]
					set Bindex [ expr $Bindex + 1 ]
				} else {
					puts "String scan error in Check_BB"
					return -1
				}
			}
			set ASICck_d0 [ lreplace $ASICck_d0 $i $i [ format "0x%02x" $a ] ]
			set ASICck_d1 [ lreplace $ASICck_d1 $i $i [ format "0x%02x" $b ] ]
			set ASICck_d2 [ lreplace $ASICck_d2 $i $i [ format "0x%02x" $c ] ]
			set ASICck_d3 [ lreplace $ASICck_d3 $i $i [ format "0x%02x" $d ] ]
		}
	} else {
		InsertLog "Not ppc! Check_BB:arrived here in error"
		set m "Not ppc! Check_BB:arrived here in error"
		return $m
	}
	# all read in to ck list. Now compare them ?
	set asic_error0 0 
	set asic_error1 0 
	set asic_error2 0 
	set asic_error3 0 
	for { set k 0 }  { $k < 28 } { incr k } {
		for { set i 0 } { $i < 4 } { incr i } {
			if { [ lindex [set ASIC_d$i ] $k ] != [ lindex [set ASICck_d$i ] $k ] } { incr asic_error$i }
		}
	}
	InsertLog "Errors :-\n 0: $asic_error0\n 1: $asic_error1\n 2: $asic_error2\n 3: $asic_error3\n"
}
   proc  show_variables {} {
       variable allmodules 
       variable allasics
       variable ASIC

       InsertLog "FEE64 = $::AIDA::FEE64; ASIC = $ASIC"
       InsertLog "all modules = $allmodules; all asics = $allasics"
   }

   proc do_redisplay {} {
    variable ASIC
    variable ASICList
    variable allasics
    variable allmodules
	variable ASIC_d0
	variable ASIC_d1
	variable ASIC_d2
	variable ASIC_d3


	set Host [ exec uname -m ]
	if { $Host == "ppc" } { ;# we're in a FEE so the list is correct
#		InsertLog "This is a ppc"
	} else {  
		set execute "exec curl -silent \"http://[set ::AIDA::FEE64]:8015/AIDA/ASIC/ASIC_BB.tml?Action=do_read\""
		set rc [catch { eval $execute } m]
		if { $rc != 0 } {
			puts "Command returned rc = $rc | m = $m"
			return -1
		}
		set big_list [ split $m \n]
		set ASIC_d0 [ lindex $big_list 10 ] ;# assuming the structure doesn't change !
		set ASIC_d1 [ lindex $big_list 11 ] ;# assuming the structure doesn't change !
		set ASIC_d2 [ lindex $big_list 12 ] ;# assuming the structure doesn't change !
		set ASIC_d3 [ lindex $big_list 13 ] ;# assuming the structure doesn't change !
		
    }

   }

   proc do_setOpt {i vl} {
    variable ASIC
    variable ASICList
    variable allasics
    variable allmodules
	variable ASIC_d0
	variable ASIC_d1
	variable ASIC_d2
	variable ASIC_d3


	set Host [ exec uname -m ]
	if { $Host == "ppc" } { ;# we're in a FEE so the list is updated direct
	    foreach asic { 0 1 2 3 } {
			if {$allasics == 0 && $asic != [ expr  $ASIC - 1 ] } continue
			set ASIC_d$asic [ lreplace [ set ASIC_d$asic ] $i $i $vl ]
		}
	} else {  
	
		set BAK $::AIDA::FEE64
		foreach fee64 $::AIDA::ModuleMenu {
			if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue
			set ::AIDA::FEE64 $fee64
			foreach asic $ASICList {
				if {$allasics == 0 && $asic != $ASIC} continue
				set execute "exec curl -silent \"http://[set ::AIDA::FEE64]:8015/AIDA/ASIC/ASIC_BB.tml?Action=do_set&asic=[expr $asic -1]&register=[set i]&value=[set vl]\""
				set rc [catch { eval $execute } m]
				if { $rc != 0 } {
					puts "Command returned rc = $rc | m = $m"
					return -1
				}
			}
		}

      set ::AIDA::FEE64 $BAK
    }
}
   proc ShowTemps {} {
      variable allmodules

      set BAK $::AIDA::FEE64

      set m ""

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

          WriteAIDARegister 0x200 0          ;#    initiate Virtex temp measurement
          set vl0 [ReadAIDARegister 0x201]   ;#  get it

          WriteAIDARegister 0x202 0          ;#    initiate PSU temp measurement
          set vl1 [ReadAIDARegister 0x203]   ;#  get it

          WriteAIDARegister 0x204 0          ;#    initiate ASIC temp measurement
          set vl2 [ReadAIDARegister 0x205]   ;#  get it

          append m "$::AIDA::FEE64\n\
                      Virtex Temp = [expr $vl0 * 0.0625]C ([format "0x%04x" $vl0])\n\
                      PSU Temp = [expr $vl1 * 0.0625]C ([format "0x%04x" $vl1])\n\
                      ASIC Temp = [expr $vl2 * 0.0625]C ([format "0x%04x" $vl2])\n"
      }

      set ::AIDA::FEE64 $BAK
     
      Alert $m

     return $m

   }

   proc LoadASIC  {} {
    variable ASIC
    variable ASICList
    variable allasics
    variable allmodules

    set BAK $::AIDA::FEE64
	set Host [ exec uname -m ]
	if { $Host == "ppc" } { ;# we're in a FEE so need to execute the C program after writing the file to /tmp
		load_BB
	} else {
		foreach fee64 $::AIDA::ModuleMenu {
			if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue
			set ::AIDA::FEE64 $fee64
			set execute "exec curl \"http://[set fee64]:8015/AIDA/ASIC/ASIC_BB.tml?Action=do_load\""
			set rc [catch {eval $execute} m]
			if { $rc != 0 } {
				puts "Command returned rc = $rc | m = $m"
				return -1
			}
		}
    }
      set ::AIDA::FEE64 $BAK
   }

   proc CheckASIC {} {
       variable ASIC
       variable ASICList
       variable allasics
      variable allmodules

    set BAK $::AIDA::FEE64
	set Host [ exec uname -m ]
	if { $Host == "ppc" } { ;# we're in a FEE so need to execute the C program after writing the file to /tmp
		check_BB
	} else {
		foreach fee64 $::AIDA::ModuleMenu {
			if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue
			set ::AIDA::FEE64 $fee64
			set execute "exec curl \"http://[set fee64]:8015/AIDA/ASIC/ASIC_BB.tml?Action=do_check\""
			set rc [catch {eval $execute} m]
			if { $rc != 0 } {
				puts "Command returned rc = $rc | m = $m"
				return -1
			}
		}
    }
      set ::AIDA::FEE64 $BAK
   }

   proc DEFAULT {} {
       variable ASIC
       variable ASICList
       variable allasics
      variable allmodules

	set Host [ exec uname -m ]
	if { $Host == "ppc" } { ;# we're in a FEE so need to execute the C program after writing the file to /tmp
		set ASIC_d0 $ASICdf_d0
		set ASIC_d1 $ASICdf_d1
		set ASIC_d2 $ASICdf_d2
		set ASIC_d3 $ASICdf_d3
		load_BB
	} else {
		foreach fee64 $::AIDA::ModuleMenu {
			if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue
			set ::AIDA::FEE64 $fee64
			set execute "exec curl \"http://[set fee64]:8015/AIDA/ASIC/ASIC_BB.tml?Action=do_default\""
			set rc [catch {eval $execute} m]
			if { $rc != 0 } {
				puts "Command returned rc = $rc | m = $m"
				return -1
			}
		}
    }
      set ::AIDA::FEE64 $BAK
   }

   proc do_action {} {
    global Httpd
	variable ASIC_d0
	variable ASIC_d1
	variable ASIC_d2
	variable ASIC_d3

      upvar #0 Httpd[set Httpd(currentSocket)] data

     set sock $Httpd(currentSocket)

     set m ""

     append m "do_action\n"
     append m "uri = $data(uri)\n"
     variable ASICList

     set info [second [split $data(uri) ?]]

     if {[string compare -length 7 "Action=" "$info"] == 0} {
		set actionlist [ split $info "=&" ]
#        set action [string range $info 7 end]
		set action [ lindex $actionlist 1 ] ;# fetch the action word.
         append m "action = $action\n"

         switch $action {
			do_hello	{ append m "\nWell Hello there!\n" }
			do_read     {
				foreach asic { 0 1 2 3 } {
					append m \n 
					append m [ set ASIC_d$asic]
				}
				append m \n
			}
			do_load		{ 
				after 100 {
					set z [catch {::ASIC_BB::load_BB} m]
					if {$z != 0} {puts "load_BB gets $m"}
				}
			}
			do_check		{ 
				after 100 {
					set z [catch {::ASIC_BB::check_BB} m]
					if {$z != 0} {puts "check_BB gets $m"}
				}
			}
			do_set		{ 
				if { [ llength $actionlist ] == 8 } { 
					set i [ lindex $actionlist 3 ]
					set reg [ lindex $actionlist 5 ]
					set vl [ lindex $actionlist 7 ]
					
					append m "\nCalled do_set using asic = $i , register = $reg , value = $vl\n"
					set ASIC_d$i [ lreplace [ set ASIC_d$i ] $reg $reg $vl ]
				} else {
					append m "\nError: Called do_set with incorrect parameter count\n"
				}
			}
			do_default		{ 
				after 100 {
					set z [catch {::ASIC_BB::DEFAULT} m]
					if {$z != 0} {puts "DEFAULT gets $m"}
				}
			}
            undefined -
            default {append m "Error: unexpected action: $action\n"}
         }
     }

      append m "*****action request done*****\n"

      Httpd_ReturnData $sock "http" $m 

}

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] == "Action"} then {do_action; return}
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   ASIC     {variable ASIC; set ASIC $vl}
                   ALLASICS {variable allasics; set allasics [expr ($allasics + 1) & 1]}

                   OPTS     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

     do_redisplay

}   ;# end of if {$started == 0}




