
#    Note:  This is loaded into the namespace  LAY

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

     variable Layout_file ""

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable Line_count 0

    variable JS ""

    variable allmodules 0
    variable module_list ""
    variable Aida_Master "Not Set"

	foreach item { 5 4 3 2 1 } {

	 	set crate [ join  [ concat "Yp" $item ] "" ]
    		variable Opt900$crate "___"
     		variable Opt901$crate "___"
     		variable Opt902$crate "___"
   		variable Opt903$crate "___"
     		variable Opt904$crate "___"
     		variable Opt905$crate "___"

	}
	foreach item { 1 2 3 4 5 } {

	 	set crate [ join  [ concat "Yn" $item ] "" ]
    		variable Opt900$crate "___"
     		variable Opt901$crate "___"
     		variable Opt902$crate "___"
   		variable Opt903$crate "___"
     		variable Opt904$crate "___"
     		variable Opt905$crate "___"

	}
	foreach item { 5 4 3 2 1 } {

	 	set slot [ join  [ concat "Xp" $item ] "" ]
    		variable Opt900$slot "___"
    		variable Opt901$slot "___"

	}
	foreach item { 5 4 3 2 1 } {

	 	set slot [ join  [ concat "Xn" $item ] "" ]
    		variable Opt900$slot "___"
    		variable Opt901$slot "___"

	}


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }

proc file_read { } { 
	global env 
	variable module_list
	variable Line_count

	set computer [set env(ComputerName)]
	append myname $computer "" ; # used to have .dl.ac.uk added in here 2Oct13
     set cf [file join $env(MIDASBASE) config TclHttpd $myname "layout.txt"]
	variable Layout_file
	set Layout_file $cf
      set z [catch {open $cf r} in_file ]
      if {!$z} {
 #        InsertLog "layout file $in_file opened from $cf"
         
      } else {
         InsertLog "Layout file $cf NOT opened "
	 return
      }
	set module_list ""
	set Line_count 0
	set file_data [ read $in_file ]
	close $in_file
	set data [ split $file_data "\n" ]
	foreach line $data {
		if { [ lindex $line 0 ] != "#" } {

			switch -exact [ lindex $line 0 ] {
				Yp {
					set crate Yp[ lindex $line 1 ]
					set posn [ expr  ( [ lindex $line 2] - 1 ) * 2  ]
					if { [ lindex $line 3 ] == "down" } {
						set posn [ expr $posn + 1 ] 
					}
					set posn [ join [ concat $posn $crate ] "" ]

					set fee64  [ lindex $line 4 ]
					
				        set rc1 [catch {exec ping -c 1 -W 1 $fee64} m1]
	   				if { $rc1 == 0 } {
						variable Opt90$posn "<font color=green>OK:$fee64<\/font>"
					} else {
						variable Opt90$posn "<font color=red>DWN:$fee64<\/font>"
					}
					lappend module_list "$fee64"
				}
				Yn {
					set crate Yn[ lindex $line 1 ]
					set posn [ expr  ( [ lindex $line 2] - 1 ) * 2  ]
					if { [ lindex $line 3 ] == "down" } {
						set posn [ expr $posn + 1 ] 
					}
					set posn [ join [ concat $posn $crate ] "" ]

					set fee64  [ lindex $line 4 ]
					
				        set rc1 [catch {exec ping -c 1 -W 1 $fee64} m1]
	   				if { $rc1 == 0 } {
						variable Opt90$posn "<font color=green>OK:$fee64<\/font>"
					} else {
						variable Opt90$posn "<font color=red>DWN:$fee64<\/font>"
					}
					lappend module_list "$fee64"
				}
				Xp {
					set slot Xp[ lindex $line 2 ]
					if { [ lindex $line 3 ] == "down" } {
						set posn 1 
					} else { 
						set posn 0 
					}
					set posn [ join [ concat $posn $slot ] "" ]

					set fee64  [ lindex $line 4 ]
					
				        set rc1 [catch {exec ping -c 1 -W 1 $fee64} m1]
	   				if { $rc1 == 0 } {
						variable Opt90$posn "<font color=green>OK:$fee64<\/font>"
					} else {
						variable Opt90$posn "<font color=red>DWN:$fee64<\/font>"
					}
					lappend module_list "$fee64"
				}
				Xn {
					set slot Xn[ lindex $line 2 ]
					if { [ lindex $line 3 ] == "down" } {
						set posn 1 
					} else { 
						set posn 0 
					}
					set posn [ join [ concat $posn $slot ] "" ]

					set fee64  [ lindex $line 4 ]
					
				        set rc1 [catch {exec ping -c 1 -W 1 $fee64} m1]
	   				if { $rc1 == 0 } {
						variable Opt90$posn "<font color=green>OK:$fee64<\/font>"
					} else {
						variable Opt90$posn "<font color=red>DWN:$fee64<\/font>"
					}
					lappend module_list "$fee64"

				}
				master {
					variable Aida_Master [ lindex $line 1 ]
				}

			}
		}
	}
}
   proc do_redisplay {} {

     variable module_list
     variable allmodules 

	

      set BAK $::AIDA::FEE64   ;#   save
	file_read

      set ::AIDA::FEE64 $BAK   ;#   restore


   }
   proc do_ShowTemps {} {
	variable temperatures
      if {![info exists ::ASIC::started]} {
          InsertLog "You must start ASIC Control Window first"
          return
      }

      set temperatures "[::ASIC::ShowTemps]"
   }
   proc do_setOpt900 {i vl} {
      variable allmodules

    }

   proc FORCE {} {
      variable allmodules
      variable module_list

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $module_list {
	    set rc1 [catch {exec ping -c 1 $fee64} m1]
            set rc2 [catch {exec /sbin/arp -a $fee64} m2]
            if {$rc1 == 0 & $rc2 == 0} {
                InsertLog "$fee64 : MAC address = [ lindex $m2 3 ]"
            } else {
		InsertLog "$fee64 : Network info missing"
	    }
      }

      set ::AIDA::FEE64 $BAK   ;#  restore

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPT900     {do_setOpt900 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    do_redisplay

}   ;# end of if {$started == 0}




